function D2 = funcD2enter(eco,q,B0,display,BG)

theta           = eco.theta;
sigma           = eco.sigma;     % log case
beta            = eco.beta;
lbar            = eco.lbar;      %labor supply when unproductive
alpha           = eco.alpha;      % 
rho             = eco.rho;      % Quarterly value 0.75
phi             = eco.phi;      % productivity scale when excluded
%BG              = eco.BG;


Uc              = eco.Uc;
Ucinv           = eco.Ucinv;
U               = eco.U;

l0              = Ucinv(1/phi)/phi;
Uv              = [U(phi*l0)-l0;U(phi*lbar)-lbar];
%M               = [alpha, 1-alpha;1-rho,rho];                       
%Wv              = inv(eye(2) - beta*M)*Uv;

Mt              = [alpha*(1-theta), 1-alpha;(1-rho)*(1-theta),rho]; 
Ut              = [alpha;1-rho];                       

V0p             = 0;
Wv              = inv(eye(2) - beta*Mt)*(Uv+beta*theta*V0p*Ut);
We              = Wv(1);
Wu              = Wv(2);

distV           = 10;

while abs(distV)>10e-6
    Wv              = inv(eye(2) - beta*Mt)*(Uv+beta*theta*V0p*Ut);
    We              = Wv(1);
    Wu              = Wv(2);

    qa              = beta*(alpha + (1-alpha)*Uc(lbar));
    nprod           = (1 - rho)/(2-alpha-rho);
    np              = 1;   
    tax             = (q-1)*BG/np;

    c0              = Ucinv(1);
    c1              = Ucinv((q./beta - alpha)./(1-alpha));
    B1              = (B0 - c1+lbar - tax)/((1-rho)*q);
    V10             = We;
    V00             = We - B1 + B0;
    V1              = U(c1) - lbar + beta*(rho*Wu +(1 - rho)*V10);
    V10b            = U(c0) - (c0 +tax - B1 + q*B0) + beta*(alpha*V00 + (1-alpha)*V1);
    
    V0pp            = V00 - B0;
    distV           = V0p -V0pp; 
    V0p             = V0pp;
    


end

V2 = -10000;
    if (lbar + B1 - (1-rho)*q*B1)>0
        V2              = U(lbar - tax + B1 - (1-rho)*q*B1) + beta*(rho*Wu +(1 - rho)*V10);
    end;
FM              = B0 +(1-alpha)*(1 - rho)*B1 + BG/np;



D2.qs       = q;
D2.B0       = B0;
D2.B1       = B1;
D2.V00      = V00;
D2.V10      = V10;
D2.V10b     = V10b;
D2.We       = We;
D2.V1       = V1;
D2.V2       = V2;
D2.Wu       = Wu;
D2.c0       = c0;
D2.c1       = c1;
D2.FM       = FM;
D2.V0p      = V0p;

D2.exist = false;
 if B0>B1 && V1>Wu && V2<Wu
     D2.exist = true;
 end;





                                